Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.cayenne.query
Interface Query

All Superinterfaces:
  ConfigurationNode, java.io.Serializable

All Known Subinterfaces:
  ParameterizedQuery

All Known Implementing Classes:
  AbstractQuery, BatchQuery, DeleteBatchQuery, EJBQLQuery, IndirectQuery, InsertBatchQuery, NamedQuery, ObjectIdQuery, PrefetchSelectQuery, ProcedureQuery, QualifiedQuery, QueryChain, RefreshQuery, RelationshipQuery, SelectQuery, SQLTemplate, UpdateBatchQuery

    public interface Query

extends java.io.Serializable, ConfigurationNode

Defines minimal API of a query descriptor that is executable via Cayenne.

Method Summary
`SQLAction` | `createSQLAction(SQLActionVisitor visitor)` A callback method invoked by Cayenne during the final execution phase of the query run.
`DataMap` | `getDataMap()`
`QueryMetadata` | `getMetaData(EntityResolver resolver)` Returns query runtime parameters.
`java.lang.String` | `getName()` Returns a symbolic name of the query.
`void` | `route(QueryRouter router, EntityResolver resolver, Query substitutedQuery)` A callback method invoked by Cayenne during the routing phase of the query execution.

Methods inherited from interface org.apache.cayenne.configuration.ConfigurationNode
`acceptVisitor`

Method Detail

### getMetaData

    QueryMetadata getMetaData(EntityResolver resolver)

  Returns query runtime parameters. The method is called at various stages of the execution by Cayenne access stack to retrieve query parameters. EntityResolver instance is passed to this method, meaning that the query doesn't need to store direct references to Cayenne mapping objects and can resolve them at runtime.

  Since:
    1.2

### route

    void route(QueryRouter router,
               EntityResolver resolver,
               Query substitutedQuery)

  A callback method invoked by Cayenne during the routing phase of the query execution. Mapping of DataNodes is provided by QueryRouter. Query should use a `QueryRouter.route(QueryEngine, Query, Query)` callback method to route itself. Query can create one or more substitute queries or even provide its own QueryEngine to execute itself.

  Since:
    1.2

### createSQLAction

    SQLAction createSQLAction(SQLActionVisitor visitor)

  A callback method invoked by Cayenne during the final execution phase of the query run. A concrete query implementation is given a chance to decide how it should be handled. Implementors can pick an appropriate method of the SQLActionVisitor to handle itself, create a custom SQLAction of its own, or substitute itself with another query that should be used for SQLAction construction.

  Since:
    1.2

### getName

    java.lang.String getName()

  Returns a symbolic name of the query. The name is normally used as a key to find queries stored in the DataMap.

  Since:
    1.1

### getDataMap

    DataMap getDataMap()

  Since:
    3.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2012 Apache Cayenne. All Rights Reserved.